%if "%{?rhel}" == "6"
%bcond_without repolib
%else
%bcond_with repolib
%endif

%define upstream_build_number b01
%define upstream_build_type FCS
%global upstreamversion %{version}-%{upstream_build_number}-%{upstream_build_type}

%define reltag _%{upstream_build_number}_redhat_3
%global namedreltagnodash redhat-3
%define namedreltag -%{upstream_build_number}-%{namedreltagnodash}
%global namedversion %{version}%{?namedreltag}

Name:           glassfish-jsf12
Version:        1.2_15
Release:        12%{?reltag}%{?dist}
Epoch:          0
Summary:        GlassFish JSF
License:        CDDL
Group:          Development/Java
URL:            https://javaserverfaces.dev.java.net/
# cvs -d :pserver:guest@cvs.dev.java.net:/cvs checkout -r JSF_1_2_15_B01 javaserverfaces-sources
Source0:        http://java.net/downloads/javaserverfaces/release/1.2_15/mojarra-1.2_15-b01-FCS-source.zip
Patch0:         mojarra-1.2_15-b01-FCS-build.patch
Patch1:         mojarra-1.2_15-b01-FCS-apache-commons.patch
Patch2:         mojarra-1.2_15-b01-FCS-pom.patch
Patch3:         glassfish-jsf-JBPAPP-6414.patch
Requires:       jpackage-utils
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
BuildRequires:  ant
BuildRequires:  ant-contrib
BuildRequires:  aqute-bndlib
BuildRequires:  commons-beanutils
BuildRequires:  jakarta-commons-digester
BuildRequires:  commons-logging
BuildRequires:  glassfish-jstl
BuildRequires:  groovy15
BuildRequires:  jboss-el-api_2.2_spec
BuildRequires:  jboss-jsp-api_2.2_spec
BuildRequires:  jetty6
BuildRequires:  jetty6-annotations
BuildRequires:  jetty6-plus
BuildRequires:  jetty6-util
BuildRequires:  portlet-1.0-api
BuildRequires:  jboss-servlet-api_3.0_spec
BuildRequires:  tlddoc
BuildRequires:  tomcat6-lib
%if %with repolib
BuildRequires:  jboss-parent
BuildRequires:  maven2-plugin-deploy
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The JSF 1.2 implementation.

NB: We've omitted the class GlassFishInjectionProvider
    from the package com.sun.faces.vendor.

%package javadoc
Summary:        Javadoc for JSF API
Group:          Documentation
Requires:       jpackage-utils

%description javadoc
Javadoc for JSF API.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n mojarra-%{upstreamversion}-sources
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%patch2 -p1 -b .sav2
%patch3 -p1 -b .sav3

%{_bindir}/find -type f \( -name "*.jar" -and -not -name bnd-0.0.249.jar \) | %{_bindir}/xargs -t %{__rm}

%{__ln_s} `%{_bindir}/build-classpath ant-contrib` common/lib/ant-contrib.jar
%if 0
%{__ln_s} `%{_bindir}/build-classpath aqute-bndlib` common/lib/bnd-0.0.249.jar
%endif
%{__mkdir_p} dependencies/jars
%{__ln_s} `%{_bindir}/build-classpath tlddoc` dependencies/jars/tlddoc-1.3.jar

%{__cp} -p build.properties.glassfish build.properties

%{__rm} -r jsf-api/build/generate jsf-ri/build/generate

%{__rm} jsf-ri/src/com/sun/faces/vendor/GlassFishInjectionProvider.java 

%build
export CLASSPATH=`%{_bindir}/build-classpath commons-beanutils commons-collections commons-digester commons-logging jboss-el-api_2.2_spec glassfish-jstl jboss-jsp-api_2.2_spec portlet-1.0-api jboss-servlet-api_3.0_spec groovy15 jetty-annotations jetty-plus jetty jetty-util tomcat6/jasper`
export OPT_JAR_LIST=:
export JSF_BUILD_HOME=`pwd`
for i in jsf-api jsf-ri; do
pushd $i
%{ant} -Dbuild.sysclasspath=first -Djsf.build.home=${JSF_BUILD_HOME} -Dbuild.number=%{upstream_build_number} -Dbuild.type=%{namedreltagnodash} -Dimpl.version=%{namedversion} dist
popd
done

%install
%{__rm} -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_javadir}/
%{__cp} -p jsf-api/build/lib/jsf-api.jar %{buildroot}%{_javadir}/jsf-api-%{namedversion}.jar
%{__cp} -p jsf-ri/build/lib/jsf-impl.jar %{buildroot}%{_javadir}/jsf-impl-%{namedversion}.jar

pushd %{buildroot}%{_javadir}
%{__ln_s} jsf-api-%{namedversion}.jar %{name}-api-%{namedversion}.jar
%{__ln_s} jsf-impl-%{namedversion}.jar %{name}-impl-%{namedversion}.jar
%{__ln_s} %{name}-api-%{namedversion}.jar %{name}-api.jar
%{__ln_s} %{name}-impl-%{namedversion}.jar %{name}-impl.jar
%if 0
%{__ln_s} jsf-api-%{namedversion}.jar jsf-api.jar
%{__ln_s} jsf-impl-%{namedversion}.jar jsf-impl.jar
%endif
popd

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p jsf-api/jsf-api-pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-api.pom
%{__cp} -p jsf-ri/jsf-impl-pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-impl.pom
%{__sed} -i s/@VERSION@/%{namedversion}/ %{buildroot}%{_mavenpomdir}/JPP-%{name}-api.pom
%{__sed} -i s/@VERSION@/%{namedversion}/ %{buildroot}%{_mavenpomdir}/JPP-%{name}-impl.pom

# depmaps
%add_to_maven_depmap javax.faces jsf-api %{namedversion} JPP %{name}-api
%add_to_maven_depmap javax.faces jsf-impl %{namedversion} JPP %{name}-impl

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/jsf-api-%{namedversion}
%{__cp} -pr jsf-api/build/javadocs/* %{buildroot}%{_javadocdir}/jsf-api-%{namedversion}
%{__ln_s} jsf-api-%{namedversion} %{buildroot}%{_javadocdir}/%{name}-api-%{namedversion}
%{__ln_s} %{name}-api-%{namedversion} %{buildroot}%{_javadocdir}/%{name}-api

%if %with repolib
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export URL=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
export MAVEN_OPTS="-Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DperformRelease -Durl=${URL}"
%{_bindir}/mvn-jpp -e deploy:deploy-file -DpomFile=%{buildroot}%{_mavenpomdir}/JPP-%{name}-api.pom -Dfile=%{buildroot}%{_javadir}/%{name}-api-%{namedversion}.jar
%{_bindir}/mvn-jpp -e deploy:deploy-file -DpomFile=%{buildroot}%{_mavenpomdir}/JPP-%{name}-impl.pom -Dfile=%{buildroot}%{_javadir}/%{name}-impl-%{namedversion}.jar
%endif

%post
%update_maven_depmap 

%postun
%update_maven_depmap

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
%doc jsf-api/LICENSE.TXT
%{_javadir}/%{name}-api.jar
%{_javadir}/%{name}-api-%{namedversion}.jar
%{_javadir}/%{name}-impl.jar
%{_javadir}/%{name}-impl-%{namedversion}.jar
%{_javadir}/jsf-api-%{namedversion}.jar
%{_javadir}/jsf-impl-%{namedversion}.jar
%if 0
%{_javadir}/jsf-api.jar
%{_javadir}/jsf-impl.jar
%endif
%{_mavenpomdir}/JPP-%{name}-api.pom
%{_mavenpomdir}/JPP-%{name}-impl.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-api-%{namedversion}
%{_javadocdir}/%{name}-api
%{_javadocdir}/jsf-api-%{namedversion}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Tue Apr 23 2013 Vladimir Dosoudil <dosoudil@redhat.com> - 0:1.2_15-12_b01_redhat_3
- BZ-901103

* Tue Mar 26 2013 David Walluck <dwalluck@redhat.com> 0:1.2_15-11
- fix Implementation-Version
- use %%{_mavenpomdir} macro
- fix file list

* Tue Jan 22 2013 David Walluck <dwalluck@redhat.com> 0:1.2_15-10
- don't use el_api, but jboss-el-api_2.2_spec
- don't use jetty6-core, but jetty6
- use jetty6-util

* Thu Sep 06 2012 David Walluck <dwalluck@redhat.com> 0:1.2_15-9
- BuildRequires: jboss-jsp-api_2.2_spec
- BuildRequires: jboss-servlet-api_3.0_spec

* Mon Aug 20 2012 Paul Gier <pgier@redhat.com> - 0:1.2_15-8_b01_redhat_2.4
- Update pom patch for eap 6.0.1

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.2_15-8_b01_redhat_2.3
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.2_15-8_b01_redhat_1.2
- Rebuild using cache signing

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.2_15-8_b01_redhat_1.1
- Rebuild using cache signing

* Thu Apr 05 2012 David Walluck <dwalluck@redhat.com> 0:1.2_15-8
- rebuild

* Wed Apr 04 2012 David Walluck <dwalluck@redhat.com> 0:1.2_15-7
- add jboss specs deps
- change parent to 8-redhat-1
- resolves JBPAPP-8525, JBPAPP-8526

* Wed Apr 04 2012 David Walluck <dwalluck@redhat.com> 0:1.2_15-6
- add global macros for build type and build number
- set build.type and build.number explictly during build
- resolves JBPAPP-8275

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.2_15-5_b01_redhat_1.1
- Rebuild using cache signing

* Thu Dec 08 2011 Permaine Cheung <pcheung@redhat.com> 0:1.2_15-5_b01_redhat_1
- Update patch for JBPAPP-6414 to match with jbossorg-2 release on nexus

* Mon Oct 24 2011 David Walluck <dwalluck@redhat.com> 0:1.2_15-4_b01_redhat_1
- add patch for JBPAPP-6414

* Fri Oct 21 2011 David Walluck <dwalluck@redhat.com> 0:1.2_15-3_b01_redhat_1
- enable Tomcat6InjectionProvider

* Fri Oct 21 2011 David Walluck <dwalluck@redhat.com> 0:1.2_15-2_b01_redhat_1
- remove patches that no longer apply cleanly

* Fri Oct 21 2011 David Walluck <dwalluck@redhat.com> 0:1.2_15-1_b01_redhat_1
- 1.2_15-b01
- add javadoc
- include LICENSE.TXT
- regenerate taglib
- use upstream build process
- use upsream poms
- remove bundled jars
- use official apache commons

* Wed Oct 19 2011 David Walluck <dwalluck@redhat.com> 0:1.2_13-6_patch_01
- fix source file names
- change to BuildRequires: maven2-plugin-deploy
- respin as glassfish-jsf12
- fix the setup command
- fix install
- fix depmaps
- fix component-info and pom from being subst'ed during build
- add missing jpackage-utils requirement for maven depmaps

* Tue Oct 11 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.2_13-5_patch_01.3
- Update patch for JBPAPP-6414

* Thu Oct 06 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.2_13-5_patch_01.2
- Update patch for JBPAPP-6414

* Wed Sep 28 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.2_13-5_patch_01.1
- Update patch for JBPAPP-6414

* Thu Sep  1 2011 Dustin Kut Moy Cheung <dcheung@redhat.com> - 0:1.2_13-4_patch_01.4
- Removed BR geronimo and changed BR tomcat6 to jbossweb

* Wed Aug 24 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.2_13-4_patch_01.3
- Rebuild to properly apply the patch

* Thu Aug 18 2011 Permaine Cheung <pcheung@redhat.com> - 0:1.2_13-4_patch_01.2
- Rebuild with 1.6.0 OpenJDK

* Tue Aug 09 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.2_13-4_patch_01.1
- Upgrade to 1.2_13-patch-01

* Wed Feb 9 2011 Yiqiao Wang <yiwang@redhat.com> - 0:1.2_13-3.1.4
- Add %%update_maven_depmap in %%post and %%postun

* Mon Jan 17 2011 Yiqiao Wang <yiwang@redhat.com> - 0:1.2_13-3.1.3
- Fix upload.sh

* Thu Dec 16 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.2_13-3.1.2
- Build with Maven 2.2.1
- Add upload.sh to repolib
- Add poms to repolib
- Fix %%files for signed jars
- Add content of maven2-brew, add BR maven-deploy-plugin

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.2_13-3.1.1
- rebuilt

* Tue Apr 20 2010 Luiz Barreiros <gbarreir@redhat.com> 0:1.2_13-4
- Rebuild

* Thu Aug 06 2009 Fernando Nasser <fnasser@redhat.com> 0:1.2_13-3
- Replace "BR jbossweb" with "BR tomcat6", drop circular deps
- BR:  geronimo-el-1.0-api
- Update glassfish-jsf-build.xml, use geronimo's el-api && annotation instead
- Add el-api to deppath

* Thu Aug 06 2009 Fernando Nasser <fnasser@redhat.com> 0:1.2_13-2
- Add updated overlay file

* Thu Aug 06 2009 Fernando Nasser <fnasser@redhat.com> 0:1.2_13-1
- Upgrade to 1.2_13
- Remove overlay

* Tue Jun 23 2009 Yong Yang <yyang@redhat.com> 0:1.2_10-0jpp.ep1.6
- BR geronimo-annotation-1.0-api

* Tue Nov 25 2008 Yong Yang <yyang@redhat.com> 0:1.2_10-0jpp.ep1.5
- BR java 1.5

* Fri Nov 21 2008 Yong Yang <yyang@redhat.com> 0:1.2_10-0jpp.ep1.4
- Bump version number

* Fri Nov 21 2008 Yong Yang <yyang@redhat.com> 0:1.2_10-0jpp.ep1.3
- BR groovy15 instead of bundling its jar

* Wed Nov 05 2008 Yong Yang <yyang@redhat.com> 0:1.2_10-0jpp.ep1.2
- updating to 1.2_10

* Thu Jul 24 2008 Jon Prindiville <jprindiv@redhat.com> 0:1.2_09-0jpp.ep1.2
- Fixing version tag

* Thu Jul 24 2008 Jon Prindiville <jprindiv@redhat.com> 0:1.2_09-0jpp.ep1.1
- Updating to 1.2_09

* Mon Jul 21 2008 Jon Prindiville <jprindiv@redhat.com> 0:1.2_08-0jpp.ep1.4
- Moving from sun-jsf to glassfish/jsf (in repolib)

* Thu Apr 24 2008 Jon Prindiville <jprindiv@redhat.com> 0:1.2_08-0jpp.ep1.3
- Output JARs now have proper MANIFEST.MFs

* Wed Mar 19 2008 Jon Prindiville <jprindiv@redhat.com> 0:1.2_08-0jpp.ep1.1
- Upgrading to 1.2_08

* Fri Nov 30 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.18
- Adding a bunch of Apache commons source to compile in with the -impl stuff

* Thu Nov 29 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.17
- Adding an "overlay" JAR containing all of the non-classfiles which our -impl
  JAR is missing when compared to Sun's (see also, note at Source1)
- Adding the overlay jar and -build.xml to %%{repodirsrc}

* Wed Nov 28 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.16
- Adding jbossweb's annotations-api.jar to the impl's classpath

* Wed Nov 28 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.15
- Fixing mistakely clobbered @API-DIR@ and @IMPL-DIR@ targets in -build.xml

* Wed Nov 28 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.14
- First complete build

* Fri Nov 23 2007 Fernando Nasser <fnasser@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.13
- Revert to sun-jaf name to please buildmagic

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.12
- Added -brew suffix.

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.11
- %%{release} twiddling (to appease the packaging gods)

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.11.p02
- Fixed build.xml path confusion.

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.10.p02
- Brain not work good today. BuildRequiring ant.

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.9.p02
- Fixed 'make new-source's omission of the jsf-impl JAR from sources

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.8.p02
- Uploaded new (non-broken!) version of Source0

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.7.p02
- Corrected %%install section, and -impl's %%setup

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.6.p02
- Unbreaking the references to the ant buildfile

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.5.p02
- Using ant rather than inlining the build in the specfile

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.4.p02
- Changed -api's javac invocation

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.3.p02
- Added -api's sources to its classpath

* Thu Nov 22 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.2.p02
- Removed version specification from BR: glassfish-jstl

* Thu Nov 22 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.1.p02
- First release. The -api JAR is building, the -impl JAR is not (yet).
